/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package garten.model;

import garten.view.Fenster;
import garten.view.FlaecheBeet;
import garten.view.FlaechePflanzen;
import garten.view.FlaecheWeg;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

/**
 *
 * @author Jan
 */
public class Gaertner implements MouseListener
{
  private Garten meinGarten;
  private Fenster fenster;
  private FlaecheBeet flbeet;
  private FlaecheWeg flweg;
  private FlaechePflanzen flpfl;

  private ArrayList<Pflanze> pflanzen;
  private ArrayList<Beet> beete;
  Pflanze1 pfl1;
  Pflanze2 pfl2;
  Pflanze3 pfl3;
  int height;
  int width;

  int[] randomwertex;
  int[] randomwertey;

  public Gaertner(Fenster fenster, FlaecheBeet flbeet, FlaecheWeg flweg,
                  FlaechePflanzen flpfl)
  {
    meinGarten = new Garten(flbeet, flweg, flpfl);
    this.fenster = fenster; //Zur späteren Steuerung Pop up usw.
    this.flpfl = flpfl;

    pflanzen = new ArrayList<>();
    beete = new ArrayList<>();

    //Initialisierung der Wege/Beete
    height = fenster.getHeight();
    width = fenster.getWidth();
    randomwertex = new int[4];
    randomwertey = new int[4];
    randomwertex[0] = 10;
    randomwertey[0] = 10;
    randomwertex[3] = width - 50;
    randomwertey[3] = height - 50;

    for (int i = 1; i < 3; i++) //erstelle Random Punkte für Wege + Beete
    {
      int wegendex = (int) (Math.random() * (170 * i) + (200 * i));
      int wegendey = (int) (Math.random() * (170 * i) + (200 * i));
      randomwertex[i] = wegendex;
      randomwertey[i] = wegendey;
    }

    for (int i = 0; i < randomwertex.length; i++) //Garten Wege hinzufügen
    {
      meinGarten.hinzufuegenWeg(randomwertex[i], randomwertey[0], randomwertex[i], randomwertey[3]);
      meinGarten.hinzufuegenWeg(randomwertex[0], randomwertey[i], randomwertex[3], randomwertey[i]);
    }
    for (int i = 0; i < randomwertex.length - 1; i++) //Garten Beete hinzufügen
    {
      for (int j = 0; j < randomwertey.length - 1; j++)
      {
        meinGarten.hinzufuegenBeet(randomwertex[i] + 10, randomwertey[j] + 10, randomwertex[i + 1] - randomwertex[i] - 20, randomwertey[j + 1] - randomwertey[j] - 20);
      }
    }
    meinGarten.zeichneWeg();
    meinGarten.zeichneBeete();
    beete = meinGarten.getBeete();
    meinGarten.randomBepflanzung();
    meinGarten.zeichnePflanzen();
    
  }

  @Override
  public void mouseClicked(MouseEvent e)
  {
    
  }

  @Override
  public void mousePressed(MouseEvent e)
  {
  }

  @Override
  public void mouseReleased(MouseEvent e)
  {
  }

  @Override
  public void mouseEntered(MouseEvent e)
  {
  }

  @Override
  public void mouseExited(MouseEvent e)
  {
  }
}
