/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package garten.model;

/**
 *
 * @author Jan 
 */
import lsystem.StochasticGrammar;

class Pflanze1 extends PflanzeImpl
{
  Pflanze1(int Xstart, int Ystart, int Generation)
  {
    super(Xstart,Ystart,Generation); 
    DELTA = (float) ((Math.PI)/10);
    startLength = 30;
    createLSystem();
    translateRules();  
  } 
 public void createLSystem()
 { 
  grammar = new StochasticGrammar(axiom); 
  grammar.addRule('F',"F[+F]F[-F]F", (float) 0.1); // add rule, and weight
  grammar.addRule('F',"F[+F]F", (float) 0.45);
  grammar.addRule('F',"F[-F]F", (float) 0.45);
  grammar.generateGrammar(generations);
  drawLength =(float) (startLength * Math.pow(0.7, (double) generations));
 }     
}
